import { generateID } from '../time-manager';
import blueDefer from '../../util/defer';
import '../../newtype.h';

export class NetMessage {
  constructor(uid, seq_no, body, type = 'other') {
    this.acked = false;
    this.container = false;
    this.notContentRelated = false;
    this.createNetworker = false;
    this.longPoll = false;

    this.copyHelper = (value, key) => {
      //$FlowIssue
      this[key] = value;
    };

    this.type = type;
    this.uid = uid;
    this.msg_id = generateID(uid);
    this.seq_no = seq_no;
    Object.defineProperty(this, 'body', {
      enumerable: false,
      configurable: true,
      writable: true,
      value: body
    });
    Object.defineProperty(this, 'deferred', {
      enumerable: false,
      configurable: true,
      writable: true,
      value: blueDefer()
    });
    Object.defineProperty(this, 'copyHelper', {
      enumerable: false,
      configurable: true,
      writable: true,
      value: this.copyHelper
    });
  }
  copyOptions(options) {
    //TODO remove this
    for (var _iterator = Object.entries(options), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var [key, val] = _ref;

      this.copyHelper(val, key);
    }
  }

  size() {
    if (this.body instanceof Uint8Array) return this.body.byteLength;else return this.body.length;
    /*
    else if (this.body != null) return this.body.length
    return 0*/
  }
  clone(seq_no, dc) {
    var copy = new NetMessage(this.uid, seq_no, this.body, this.type);
    var result = clone(this, copy, dc);
    return result;
  }
  // toJSON() {
  //   return {
  //     uid      : this.uid,
  //     deferred : this.deferred,
  //     requestID: this.requestID,
  //     noShedule: this.noShedule,

  //   }
  // }
}

export class NetContainer extends NetMessage {
  constructor(uid, seq_no, body, inner, innerApi) {
    super(uid, seq_no, body);
    this.type = 'container';
    this.container = true;
    this.inner = inner;
    this.innerAPI = innerApi;
  }
  clone(seq_no, dc) {
    var copy = new NetContainer(this.uid, seq_no, this.body, this.inner, this.innerAPI /*:: || [] */);
    var result = clone(this, copy, dc);
    return result;
  }
}

function clone(orig, copy, dc) {
  copy.dc = dc;
  copy.isAPI = orig.isAPI;
  copy.notContentRelated = orig.notContentRelated;
  copy.deferred = orig.deferred;
  copy.acked = orig.acked;
  copy.noShedule = orig.noShedule;
  copy.createNetworker = orig.createNetworker;
  copy.resultType = orig.resultType;
  return copy;
}
//# sourceMappingURL=net-message.js.map