'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.authRequest = exports.makeAuthRequest = undefined;

var _ramda = require('ramda');

var _fluture = require('fluture');

var _authorizer = require('./authorizer');

var _authorizer2 = _interopRequireDefault(_authorizer);

var _networker = require('./networker');

var _configProvider = require('../config-provider');

var _configProvider2 = _interopRequireDefault(_configProvider);

var _request = require('./main/request');

var _request2 = _interopRequireDefault(_request);

var _monadT = require('../util/monad-t');

var _query = require('../state/query');

var _portal = require('../state/portal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var makeAuthRequest = exports.makeAuthRequest = netReq => _monadT.MaybeT.toFuture(ERR.noDC, (0, _query.queryHomeDc)(netReq.uid)).chain(dc => withDC(netReq.uid, dc)).map(networker => networker.wrapApiCall(netReq)).chain(msg => (0, _fluture.tryP)(() => msg.deferred.promise)).mapRej((0, _ramda.tap)(e => netReq.defer.reject(e))).chain(() => (0, _fluture.tryP)(() => netReq.defer.promise));


function withDC(uid, dc) {
  var newThread = (auth, salt) => () => (0, _networker.createThread)(dc, auth, salt, uid);

  var getThread = _configProvider2.default.thread.get(uid, dc);

  // const state = getState()
  // const client = state.client[uid]
  // const homeStatus = client.status
  //   .maybeGetK(dc)
  //   .fold(() => false, () => true)
  // if (homeStatus) {
  //   const salt = client.salt.get(dc)
  //   const auth = client.auth.get(dc)
  //   return ofF(foldGetThread({ auth, salt }))
  // }
  // const salt = state.client[uid].salt.get(dc)
  // const auth = state.client[uid].auth.get(dc)
  //
  // return Future((rj, rs) => { rs({ salt, auth }) } )
  //   .map(foldGetThread)
  return _monadT.MaybeT.toFutureR(queryKeys(uid, dc))
  // .mapRej(x => {
  //   const xx = [uid, dc, queryKeys(uid, dc)]
  //
  //   // console.warn(, uid, dc)
  //   return x
  // })
  .chainRej(() => authRequest(uid, dc)).map(({ auth, salt }) => _monadT.MaybeT.fold(newThread(auth, salt), getThread));
}

var authRequest = exports.authRequest = (uid, dc) => (0, _authorizer2.default)(uid, dc).bimap((0, _ramda.tap)(e => console.error('Auth error', e.message, e.stack)), ({
  authKey, authKeyID, serverSalt, dc
}) => ({
  auth: authKey,
  salt: serverSalt,
  // authKeyID,
  dc
}));

var queryKeys = (uid, dc) => _monadT.MaybeT.both((0, _query.queryAuthKey)(uid, dc), (0, _query.querySalt)(uid, dc)).map(([auth, salt]) => ({ auth, salt, dc }));

var ERR = {
  noDC: () => /*:: typedError(NoDCError,*/
  new Error('get Networker without dcID') /*::) */
  , isNothing() {
    throw new Error(`UnsafeMaybeValue recieve nothing`);
  }
};
//# sourceMappingURL=invoke.js.map